
public class ICS102Section {
	private int sectionNumber;
	private int numStudent;
	private final int MAXIMUMCAPACITY = 30;
	private Student[] student;
	public ICS102Section(int sectionNumber, int numStudents) throws IllegalArgumentException {
		if (sectionNumber<0) {
			throw new IllegalArgumentException("section number < 0");
		}else if (numStudents <5 ) {
			throw new IllegalArgumentException("number of student  < 5");
		}else if (numStudents > 30) {
			throw new IllegalArgumentException("number of student  > 30");
		}
		this.sectionNumber = sectionNumber;
		this.numStudent = numStudents;
		this.student = new Student[numStudents];
	}
	
	public int getSectionNumber() {
		return sectionNumber;
	}
	public int getNumStudent() {
		return numStudent;
	}
	
	public Student[] getStudentArray() {
		Student[] returnArray = new Student[this.student.length];
		for (int i =0;i<this.student.length;i++) {
			returnArray[i] = this.student[i];
		}
		return returnArray;
	}
	
	public double getSectionQuizAverage(int numQuiz) throws IllegalArgumentException {
		if(numQuiz > 5 || numQuiz < 1)
			throw new IllegalArgumentException("invalid quiz number.");
		double avg = 0;
		int counter =0;
		for (int i = 0; i < this.student.length; i++) {
			if( this.student[i] != null && this.student[i].getClass() == Student.class) {
				avg += this.student[i].getQuizGrades()[numQuiz-1];
				counter++;
			}
		}
		return avg/counter;
	}
	
	public void addStudent(Student  s) throws IllegalArgumentException {
		if(s == null) 
			throw new IllegalArgumentException("invalid student");
		
		int index = 0;
		boolean added = false;
		while(index < MAXIMUMCAPACITY && !added) {
			if(this.student[index]==null) {
				this.student[index] = s;
				added = true;
			}else {
				added =false;
				index++;
			}
		}
	}
	
	public String toString() {
		String roster = "";
		for (Student s : student) 
			if( s != null && s.getClass() == Student.class) 
				roster += String.format("%9d %20s %3.1f %3.1f %3.1f %3.1f %3.1f %n",s.getId(),s.getStudentName(),s.getQuizGrades()[0],s.getQuizGrades()[1],s.getQuizGrades()[2],s.getQuizGrades()[3],s.getQuizGrades()[4]);
		return roster;
	}
}
