
import java.io.*;
import java.util.InputMismatchException;
import java.util.Scanner;
public class Q1 {
	public static void main(String[] args) throws IOException{
		
		Scanner consoleScanner = new Scanner(System.in);
		ICS102Section section = new ICS102Section(1,30);
		try {
			loadClass(section);
		} catch (FileNotFoundException e) {
			System.err.println(e);
		}
		int choice=0;
		int input;
		boolean exit = false;
		do {
			System.out.println("1. Display all students.");
			System.out.println("2. Display section quiz average for a particular quiz.");
			System.out.println("3. Display a student and his quiz average.");
			System.out.println("4. Exit.");
			try {
				System.out.print("Please enter your choice : ");
				choice = consoleScanner.nextInt();
				switch (choice) {
				case 1:
					System.out.println();
					displayClassRoster(section);
					break;
				case 2:
					System.out.print("enter the required quiz [1-5] : ");
					input = consoleScanner.nextInt();
					sectionQuizAverage(section, input);
					break;
				case 3:
					System.out.print("Enter the ID# number of the student : ");
					input = consoleScanner.nextInt();
					displayStudentInfo(section, input);
					break;
				case 4:
					exit = true;
					break;
				default:
					System.out.println("Invalid choice");
					break;
				}
				
			} catch (IllegalArgumentException e) {
				System.err.println(e);
			} catch (InputMismatchException e) {
				System.err.println(e);
				consoleScanner.nextLine();
			}
			
			if(choice != 4)
				hold();
			
		} while (!exit);
		
	}
	
	
	private static void loadClass(ICS102Section section) throws FileNotFoundException {
		FileInputStream fileInStream = new FileInputStream("grades.txt");
		Scanner fileScanner = new Scanner(fileInStream) ;
		Scanner lineScanner;
		while(fileScanner.hasNextLine()) {
			lineScanner = new Scanner(fileScanner.nextLine());
			int id = lineScanner.nextInt();
			String name = lineScanner.next() +" "+ lineScanner.next();
			double[] quizzesGrades = new double[5];
			for (int i = 0; i < quizzesGrades.length; i++) {
				quizzesGrades[i] = lineScanner.nextDouble();
			}
			Student s = new Student(id,name,quizzesGrades);
			section.addStudent(s);
		}
		
		fileScanner.close();
	}
	
	private static void displayClassRoster(ICS102Section icsSection) {
		System.out.printf("%9S %20S %3S %3S %3S %3S %3S %n","ID","Name","Qz1","Qz2","Qz3","Qz4","Qz5");
		System.out.println(icsSection);
	}
	
	private static void sectionQuizAverage(ICS102Section section,int numQuiz) {
		System.out.printf("the section average for quiz#%d is %.1f %n",numQuiz,section.getSectionQuizAverage(numQuiz));
	}
	
	private static void displayStudentInfo(ICS102Section icsSection,int id) {
		Student[] section = icsSection.getStudentArray();
		boolean found=false;
		Student dummyStudent = new Student(id);
		for (Student s : section) {
			if(!found && s != null && s.equals(dummyStudent)) {
				System.out.printf("%9S %20S %3S %3S %3S %3S %3S %3S %n","ID","Name","Qz1","Qz2","Qz3","Qz4","Qz5","avg");
				System.out.println(s+" "+s.getQuizAverage());
				found = true;
			}
		}
		if(!found) {
			System.out.println("Error : student not found");
		}
	}
	
	private static void hold() {
		Scanner tempScanner= new Scanner(System.in);
		System.out.println("press enter to continue ...");
		tempScanner.nextLine();
	}
	
	
}
