
public class Student {
	
	private final int id;
	private final String studentName;
	private double[] quizGrades;
	
	public Student(int id)throws IllegalArgumentException {
		if(id <= 0 )
			throw new IllegalArgumentException("invalid id");
		this.id = id;
		this.studentName = "dummy student object";
	}
	
	public Student(int id, String studentName, double[] quizGrades) {
		if(id <= 0 )
			throw new IllegalArgumentException("invalid id");
		if(studentName.trim().isEmpty())
			throw new IllegalArgumentException("invalid name");
		for (int i = 0; i < quizGrades.length; i++) {
			if(quizGrades[i]<0 || quizGrades[i]>5) {
				throw new IllegalArgumentException("invalid quiz grade");
			}
		}
		this.id = id;
		this.studentName = studentName;
		this.quizGrades = quizGrades;
	}
	
	public Student(Student s) {
		id = s.id;
		studentName = s.studentName;
		quizGrades = s.quizGrades;
	}
	
	public int getId() {
		return id;
	}

	public String getStudentName() {
		return studentName;
	}

	public double[] getQuizGrades() {
		double[] returnArray = new double[this.quizGrades.length];
		for (int i =0;i<this.quizGrades.length;i++) {
			returnArray[i] = this.quizGrades[i];
		}
		return returnArray;
	}


	public double getQuizAverage( ) {
		double[] grades = getQuizGrades();
		double sum = 0;
		for (int i = 0; i < grades.length; i++) 
			sum += grades[i];
			
		return sum/getQuizGrades().length;
	}
	
	public String toString( ) {
		  return String.format("%9d %20s %3.1f %3.1f %3.1f %3.1f %3.1f",this.id,this.studentName,this.getQuizGrades()[0],this.getQuizGrades()[1],this.getQuizGrades()[2],this.getQuizGrades()[3],this.getQuizGrades()[4]);
	}
	
	public boolean equals(Student  student) {
		if(this.id == student.id)
			return true;
		else
			return false;
	}

}	
